--*** Gouraud-shaded cube ***--
--** By Mic, Nov. 1999     **--

without warning

include render.e
include stuff.e

sequence points,points2
sequence faces,order,zNormals
sequence pal
sequence v,dv	
sequence shades
atom vscreen
atom time1,time2,frames

vscreen=allocate(64000)		--allocate a virtual screen

points2={
 {-1,-1,-1},
 {1,-1,-1},
 {1,1,-1},
 {-1,1,-1},
 {-1,-1,1},
 {1,-1,1},
 {1,1,1},
 {-1,1,1}
}
points2=points2*45

--** shades for each of the six faces **--
shades={
{8,38,62,25},			--one color for each corner...
{8,38,62,25},
{8+63,38+63,62+63,25+63},
{8+126,38+126,62+126,25+126},
{8+63,38+63,62+63,25+63},
{8+126,38+126,62+126,25+126}
}

pal=repeat({0,0,0},256)
for i=1 to 63 do
 pal[i]={i,0,0}		--red gradient
 pal[63+i]={0,i,0}	--...green dito
 pal[126+i]={0,0,i}	--...blue
end for

--** set mode 19 (320*200) and set the new palette **--
set_vga()
set_pal(pal)

v={1,1,1}		--initial angles of object (x,y,z)
dv={2,2,2}		--delta (growing speed) of angles
frames=0		--reset frame counter
time1=time()

while get_key()=-1 do 
 mem_cls(vscreen,0)
 --** Rotate the points **--
 points=rotate(points2,{1,1,1},v)
 faces={
  points[1..4],						--front face
  points[5..8],						--back face
  {points[1],points[2],points[6],points[5]},	--top face
  {points[6],points[2],points[3],points[7]},	--right face
  {points[4],points[3],points[7],points[8]},	--bottom face
  {points[1],points[5],points[8],points[4]}  	--left face
 }
  --** Get the z-normals of the faces **--
 zNormals=get_quad_zNormal(faces) 
 --** sort the faces and project them to 2D **--
 order=sort_faces(faces)
 faces=get_screen_xy({150,100},faces) 	--center the cube at {150,80}	
 for i=1 to 6 do
  --** Is the face visible ? **--
  if zNormals[order[i]]<0 then
   asm_gouraudquad_ex(faces[order[i]],shades[order[i]],vscreen)
  end if
 end for
-- wait_vrt()
 asm_show_buffer(vscreen)		--copy the virtual screen to video memory
 frames=frames+1				--another frame has been draw...
 v=v+dv
 for i=1 to 3 do
  if v[i]>=361 then
   v[i]=1
  end if
  if v[i]<1 then
   v[i]=360
  end if
 end for
 --** Randomize the rotation **--
 if rand(150)=1 then
  dv=rand({6,6,6})-3
 end if
end while
time2=time()


--** restore the graphics mode and free some memory **--
shut_down()

free(vscreen)

printf(1,"%d frames per second.\n",floor(frames/(time2-time1)))
