include asm.e


--*** Variables for use with hline drawers ***--
--*** There are 200 lines on the screen, 200 DWORDS makes 800 bytes... ***--
global constant asm_xmin=allocate(800),		
         asm_xmax=allocate(800),
  	 asm_cmin=allocate(800),
	 asm_cmax=allocate(800),
         asm_umin=allocate(800),asm_umax=allocate(800),
         asm_vmin=allocate(800),asm_vmax=allocate(800)


--** <Assembly code> **--
--** <Poly fillers> **--

--** draw a number of horizontal lines with constant color **--
global constant hl_code=get_asm(
"pusha cld "&
"mov ecx,hl_numlines "&
"mov ebp,hl_y "&
"lea ebx,[ebp*4] "&
"lea ebp,[ebp + ebp*4] "&
"lea ebp,[ebp*8] "&
"lea ebp,[ebp*8] "&
"hl_@yloop: "&
"push ecx "&
"mov edi,hl_scraddr "&
"add edi,ebp "&
"mov eax,[asm_xmin + ebx] "&
"cmp eax,319 "&
"jg hl_@skip "&
"cmp eax,0 "&
"jnl hl_@xmin_nl_0 "&
"mov eax,0 "&
"hl_@xmin_nl_0: "&
"mov ecx,[asm_xmax + ebx] "&
"cmp ecx,0 "&
"jl hl_@skip "&
"cmp ecx,319 "&
"jng hl_@xmax_ng_319 "&
"mov ecx,319 "&
"hl_@xmax_ng_319: "&
"add edi,eax "&
"sub ecx,eax "&
"inc ecx "&
"mov eax,hl_color "&
"rep stosb "&
"hl_@skip: "&
"add ebx,4 "&
"pop ecx "&
"add ebp,320 "&
"dec ecx "&
"jnz hl_@yloop "&
"popa ret")
global constant hl_numlines=hl_code+get_param("hl_numlines")
global constant hl_y=hl_code+get_param("hl_y")
global constant hl_scraddr=hl_code+get_param("hl_scraddr")
global constant hl_color=hl_code+get_param("hl_color")
resolve_param("asm_xmax",hl_code,asm_xmax)
resolve_param("asm_xmin",hl_code,asm_xmin)


--*** Draw a number of shaded horizontal lines (for use with gouraud poly-drawers). ***--
global constant ghl_code=get_asm(
"pusha cld "&
"mov ecx,ghl_numlines "&
"mov ebp,ghl_y "&
"lea ebx,[ebp*4] "&
"lea ebp,[ebp + ebp*4] "&
"lea ebp,[ebp*8] "&
"lea ebp,[ebp*8] "&
"ghl_@yloop: "&
"push ecx "&
"mov edi,ghl_scraddr "&
"add edi,ebp "&
"mov eax,[asm_xmin + ebx] "&
"cmp eax,319 "&
"jg ghl_@skip "&
"cmp eax,0 "&
"jnl ghl_@xmin_nl_0 "&
"mov eax,0 "&
"ghl_@xmin_nl_0: "&
"mov ecx,[asm_xmax + ebx] "&
"cmp ecx,0 "&
"jl ghl_@skip "&
"cmp ecx,319 "&
"jng ghl_@xmax_ng_319 "&
"mov ecx,319 "&
"ghl_@xmax_ng_319: "&
"add edi,eax "&
"sub ecx,eax "&
"inc ecx "&
"mov eax,[asm_cmax + ebx] "&
"mov edx,[asm_cmin + ebx] "&
"sub eax,edx "&
"cwd "&
"idiv ecx "&
"mov edx,eax "&
"mov eax,[asm_cmin + ebx] "&
"ghl_@xloop: "&
"mov [edi],ah "&
"add ax,dx "&
"inc edi "&
"loop ghl_@xloop "&
"ghl_@skip: "&
"add ebx,4 "&
"pop ecx "&
"add ebp,320 "&
"dec ecx "&
"jnz ghl_@yloop "&
"popa ret")
global constant ghl_numlines=ghl_code+get_param("ghl_numlines")
global constant ghl_y=ghl_code+get_param("ghl_y")
global constant ghl_scraddr=ghl_code+get_param("ghl_scraddr")
resolve_param("asm_xmax",ghl_code,asm_xmax)
resolve_param("asm_xmin",ghl_code,asm_xmin)
resolve_param("asm_cmax",ghl_code,asm_cmax)
resolve_param("asm_cmin",ghl_code,asm_cmin)



--** data for texture-filler **--
global constant thl_deltaX=allocate(4)

--*** Draw a number of textured horizontal lines (for use with texture poly-drawers). ***--
global constant thl_code=get_asm(
"pusha cld "&
"mov ecx,thl_numlines "&
"mov edx,thl_y "&
"lea ebx,[edx*4] "&
"lea edx,[edx + edx*4] "&
"lea edx,[edx*8] "&
"lea edx,[edx*8] "&
"thl_@yloop: "&
"push ecx "&
"mov edi,thl_scraddr "&
"add edi,edx "&
"mov eax,[asm_xmin + ebx] "&
"cmp eax,319 "&
"jg thl_@bus_stop1 "&
"cmp eax,0 "&
"jnl thl_@xmin_nl_0 "&
"mov eax,0 "&
"thl_@xmin_nl_0: "&
"mov ecx,[asm_xmax + ebx] "&
"cmp ecx,0 "&
"jl thl_@bus_stop1 "&
"cmp ecx,319 "&
"jng thl_@xmax_ng_319 "&
"mov ecx,319 "&
"thl_@xmax_ng_319: "&
"add edi,eax "&
"sub ecx,eax "&
"push edx "&
"inc ecx "&
"mov eax,[asm_umax + ebx] "&
"mov edx,[asm_umin + ebx] "&
"sub eax,edx "&
"cwd "&
"idiv ecx "&
"mov [thl_deltax],eax "&
"jmp thl_@do_stuff "&
"thl_@bus_stop1: "&
"jmp thl_@skip "&
"thl_@bus_stop2: "&
"jmp thl_@yloop "&
"thl_@do_stuff: "&
"mov eax,[asm_vmax + ebx] "&
"mov edx,[asm_vmin + ebx] "&
"sub eax,edx "&
"cwd "&
"idiv ecx "&
"mov ebp,eax "&
"mov eax,[asm_umin + ebx] "&
"mov edx,[asm_vmin + ebx] "&
"push ebx "&
"mov esi,thl_texture "&
"mov ebx,ebp "&
"thl_@xloop: "&
"mov ebp,edx "&
"mov dl,ah "&
"mov dl,[esi+edx] "&
"mov [edi],dl "&
"mov edx,ebp "&
"add edx,ebx "&
"add eax,[thl_deltax] "&
"inc edi "&
"loop thl_@xloop "&
"pop ebx "&
"pop edx "&
"thl_@skip: "&
"add ebx,4 "&
"pop ecx "&
"add edx,320 "&
"dec cx "&
"jnz thl_@bus_stop2 "&
"popa ret")
global constant thl_numlines=thl_code+get_param("thl_numlines")
global constant thl_y=thl_code+get_param("thl_y")
global constant thl_scraddr=thl_code+get_param("thl_scraddr")
global constant thl_texture=thl_code+get_param("thl_texture")
resolve_param("asm_xmax",thl_code,asm_xmax)
resolve_param("asm_xmin",thl_code,asm_xmin)
resolve_param("asm_umax",thl_code,asm_umax)
resolve_param("asm_umin",thl_code,asm_umin)
resolve_param("asm_vmax",thl_code,asm_vmax)
resolve_param("asm_vmin",thl_code,asm_vmin)
resolve_param("thl_deltax",thl_code,thl_deltaX)

--** </Poly fillers> **--

--** </Linear interpolators> **--

--STRUCT sps_data {
-- DWORD x1,x2,y1,y2
--}
global constant sps_data=allocate(16)

--** scan_poly_side **--
global constant sps_code=get_asm(
"pusha cld "&
"mov eax,[sps_y2] "&
"mov ebx,[sps_y1] "&
"cmp eax,ebx "&
"jne sps_@do_stuff "&
"popa ret "&
"sps_@do_stuff: "&
"cmp eax,ebx "&
"jnl sps_@y2_nl_y1 "&
"mov [sps_y2],ebx "&
"mov [sps_y1],eax "&
"mov eax,[sps_x2] "&
"mov ebx,[sps_x1] "&
"mov [sps_x2],ebx "&
"mov [sps_x1],eax "&
"sps_@y2_nl_y1: "&
"mov eax,[sps_x2] "&
"sub eax,[sps_x1] "&
"sal eax,7 "&
"cwd "&
"mov ebx,[sps_y2] "&
"sub ebx,[sps_y1] "&
"idiv ebx "&
"mov edi,eax "&
"mov edx,[sps_x1] "&
"sal edx,7 "&
"mov ebx,[sps_y2] "&
"inc ebx "&
"mov ecx,[sps_y1] "&
"sps_@loop: "&
"cmp ecx,0 "&
"jl sps_@skip "&
"cmp ecx,200 "&
"jge sps_@skip "&
"mov ebp,ecx "&
"mov esi,edx "&
"sar edx,7 "&
"lea ecx,[ecx*4] "&
"cmp edx,[sps_xmin + ecx] "&
"jnl sps_@x_nl_xmin "&
"mov [sps_xmin + ecx],edx "&
"sps_@x_nl_xmin: "&
"cmp edx,[sps_xmax + ecx] "&
"jng sps_@x_ng_xmax "&
"mov [sps_xmax + ecx],edx "&
"sps_@x_ng_xmax: "&
"mov ecx,ebp "&
"mov edx,esi "&
"sps_@skip: "&
"add edx,edi "&
"inc ecx "&
"cmp ecx,ebx "&
"jne sps_@loop "&
"popa ret")
resolve_param("sps_x1",sps_code,sps_data)
resolve_param("sps_x2",sps_code,sps_data+4)
resolve_param("sps_y1",sps_code,sps_data+8)
resolve_param("sps_y2",sps_code,sps_data+12)
resolve_param("sps_xmin",sps_code,asm_xmin)
resolve_param("sps_xmax",sps_code,asm_xmax)


--STRUCT sgps_data {
-- DWORD x1,x2,y1,y2
-- DWORD c1,c2
--}
global constant sgps_data=allocate(24)

--** scan_gouraudpoly_side **--
global constant sgps_code=get_asm(
"pusha cld "&
"mov eax,[sgps_y2] "&
"mov ebx,[sgps_y1] "&
"cmp eax,ebx "&
"jne sgps_@do_stuff "&
"popa ret "&
"sgps_@do_stuff: "&
"cmp eax,ebx "&
"jnl sgps_@y2_nl_y1 "&
"mov [sgps_y2],ebx "&
"mov [sgps_y1],eax "&
"mov eax,[sgps_x2] "&
"mov ebx,[sgps_x1] "&
"mov [sgps_x2],ebx "&
"mov [sgps_x1],eax "&
"mov eax,[sgps_c2] "&
"mov ebx,[sgps_c1] "&
"mov [sgps_c2],ebx "&
"mov [sgps_c1],eax "&
"sgps_@y2_nl_y1: "&
"mov eax,[sgps_c2] "&
"sub eax,[sgps_c1] "&
"sal eax,8 "&
"cwd "&
"mov ebx,[sgps_y2] "&
"sub ebx,[sgps_y1] "&
"idiv ebx "&
"mov edi,eax "&
"mov eax,[sgps_x2] "&
"sub eax,[sgps_x1] "&
"sal eax,7 "&
"cwd "&
"idiv ebx "&
"mov esi,eax "&
"mov ebp,[sgps_c1] "&
"sal ebp,8 "&
"mov edx,[sgps_x1] "&
"sal edx,7 "&
"mov ebx,[sgps_y2] "&
"inc ebx "&
"mov ecx,[sgps_y1] "&
"sgps_@loop: "&
"cmp ecx,0 "&
"jl sgps_@skip "&
"cmp ecx,200 "&
"jge sgps_@skip "&
"push edx "&
"push ecx "&
"sar edx,7 "&
"lea ecx,[ecx*4] "&
"cmp edx,[sgps_xmin + ecx] "&
"jnl sgps_@x_nl_xmin "&
"mov [sgps_xmin + ecx],edx "&
"mov [sgps_cmin + ecx],ebp "&
"sgps_@x_nl_xmin: "&
"cmp edx,[sgps_xmax + ecx] "&
"jng sgps_@x_ng_xmax "&
"mov [sgps_xmax + ecx],edx "&
"mov [sgps_cmax + ecx],ebp "&
"sgps_@x_ng_xmax: "&
"pop ecx "&
"pop edx "&
"sgps_@skip: "&
"add edx,esi "&
"add ebp,edi "&
"inc ecx "&
"cmp ecx,ebx "&
"jne sgps_@loop "&
"popa ret")
resolve_param("sgps_x1",sgps_code,sgps_data)
resolve_param("sgps_x2",sgps_code,sgps_data+4)
resolve_param("sgps_y1",sgps_code,sgps_data+8)
resolve_param("sgps_y2",sgps_code,sgps_data+12)
resolve_param("sgps_c1",sgps_code,sgps_data+16)
resolve_param("sgps_c2",sgps_code,sgps_data+20)
resolve_param("sgps_xmin",sgps_code,asm_xmin)
resolve_param("sgps_xmax",sgps_code,asm_xmax)
resolve_param("sgps_cmin",sgps_code,asm_cmin)
resolve_param("sgps_cmax",sgps_code,asm_cmax)


--STRUCT stps_data {
-- DWORD x1,x2,y1,y2
-- DWORD u1,u2,v1,v2
-- DWORD deltaX,deltaU,deltaV
--}
global constant stps_data=allocate(44)

--** scan_texturepoly_side **--
global constant stps_code=get_asm(
"pusha cld "&
"mov eax,[stps_y2] "&
"mov ebx,[stps_y1] "&
"cmp eax,ebx "&
"jne stps_@do_stuff "&
"popa ret "&
"stps_@do_stuff: "&
"cmp eax,ebx "&
"jnl stps_@y2_nl_y1 "&
"mov [stps_y2],ebx "&
"mov [stps_y1],eax "&
"mov eax,[stps_x2] "&
"mov ebx,[stps_x1] "&
"mov [stps_x2],ebx "&
"mov [stps_x1],eax "&
"mov eax,[stps_u2] "&
"mov ebx,[stps_u1] "&
"mov [stps_u2],ebx "&
"mov [stps_u1],eax "&
"mov eax,[stps_v2] "&
"mov ebx,[stps_v1] "&
"mov [stps_v2],ebx "&
"mov [stps_v1],eax "&
"stps_@y2_nl_y1: "&
"mov eax,[stps_u2] "&
"sub eax,[stps_u1] "&
"sal eax,8 "&
"cwd "&
"mov ebx,[stps_y2] "&
"sub ebx,[stps_y1] "&
"idiv ebx "&
"mov [stps_deltaU],eax "&
"mov eax,[stps_v2] "&
"sub eax,[stps_v1] "&
"sal eax,8 "&
"cwd "&
"idiv ebx "&
"mov [stps_deltaV],eax "&
"mov eax,[stps_x2] "&
"sub eax,[stps_x1] "&
"sal eax,7 "&
"cwd "&
"idiv ebx "&
"mov [stps_deltaX],eax "&
"mov ebp,[stps_u1] "&
"sal ebp,8 "&
"mov esi,[stps_v1] "&
"sal esi,8 "&
"mov edx,[stps_x1] "&
"sal edx,7 "&
"mov ebx,[stps_y2] "&
"inc ebx "&
"mov ecx,[stps_y1] "&
"stps_@loop: "&
"cmp ecx,0 "&
"jl stps_@skip "&
"cmp ecx,200 "&
"jge stps_@skip "&
"push edx "&
"push ecx "&
"sar edx,7 "&
"lea ecx,[ecx*4] "&
"cmp edx,[stps_xmin + ecx] "&
"jnl stps_@x_nl_xmin "&
"mov [stps_xmin + ecx],edx "&
"mov [stps_umin + ecx],ebp "&
"mov [stps_vmin + ecx],esi "&
"stps_@x_nl_xmin: "&
"cmp edx,[stps_xmax + ecx] "&
"jng stps_@x_ng_xmax "&
"mov [stps_xmax + ecx],edx "&
"mov [stps_umax + ecx],ebp "&
"mov [stps_vmax + ecx],esi "&
"stps_@x_ng_xmax: "&
"pop ecx "&
"pop edx "&
"stps_@skip: "&
"add edx,[stps_deltaX] "&
"add ebp,[stps_deltaU] "&
"add esi,[stps_deltaV] "&
"inc ecx "&
"cmp ecx,ebx "&
"jne stps_@loop "&
"popa ret")
resolve_param("stps_x1",stps_code,stps_data)
resolve_param("stps_x2",stps_code,stps_data+4)
resolve_param("stps_y1",stps_code,stps_data+8)
resolve_param("stps_y2",stps_code,stps_data+12)
resolve_param("stps_u1",stps_code,stps_data+16)
resolve_param("stps_u2",stps_code,stps_data+20)
resolve_param("stps_v1",stps_code,stps_data+24)
resolve_param("stps_v2",stps_code,stps_data+28)
resolve_param("stps_deltaX",stps_code,stps_data+32)
resolve_param("stps_deltaU",stps_code,stps_data+36)
resolve_param("stps_deltaV",stps_code,stps_data+40)
resolve_param("stps_xmin",stps_code,asm_xmin)
resolve_param("stps_xmax",stps_code,asm_xmax)
resolve_param("stps_umin",stps_code,asm_umin)
resolve_param("stps_umax",stps_code,asm_umax)
resolve_param("stps_vmin",stps_code,asm_vmin)
resolve_param("stps_vmax",stps_code,asm_vmax)


global constant reset_minmax_buffers=get_asm(
"pusha cld "&
"mov edi,rmmb_xmin "&
"mov ecx,200 "&
"mov eax,8000 "&
"rep stosd "&
"neg eax "&
"mov edi,rmmb_xmax "&
"mov ecx,200 "&
"rep stosd "&
"popa ret")
resolve_param("rmmb_xmin",reset_minmax_buffers,asm_xmin)
resolve_param("rmmb_xmax",reset_minmax_buffers,asm_xmax)


--** </Assembly code> **--



--** <Main routines> (experimental versions.  ...kinda.) **--

global procedure asm_tri_ex(sequence triCoords,integer triCol,atom triAddr)
integer ymin,ymax
 call(reset_minmax_buffers)
 poke4(sps_data,{triCoords[1][1],triCoords[2][1],triCoords[1][2],triCoords[2][2]})
 call(sps_code)
 poke4(sps_data,{triCoords[2][1],triCoords[3][1],triCoords[2][2],triCoords[3][2]})
 call(sps_code)
 poke4(sps_data,{triCoords[3][1],triCoords[1][1],triCoords[3][2],triCoords[1][2]})
 call(sps_code)
 ymin=triCoords[1][2]
 ymax=ymin
 for i=2 to 3 do
  if triCoords[i][2]<ymin then ymin=triCoords[i][2] end if
  if triCoords[i][2]>ymax then ymax=triCoords[i][2] end if
 end for 
 if (ymax>=0 and ymin<200) then
  if ymin<0 then ymin=0 end if
  if ymax>199 then ymax=199 end if
  poke4(hl_y,ymin)
  poke4(hl_numlines,(ymax-ymin)+1)
  poke4(hl_color,triCol)
  poke4(hl_scraddr,triAddr)
  call(hl_code)
 end if
end procedure

global procedure asm_gouraudtri_ex(sequence triCoords,sequence triCol,atom triAddr)
integer ymin,ymax
 call(reset_minmax_buffers)
 poke4(sgps_data,{triCoords[1][1],triCoords[2][1],triCoords[1][2],triCoords[2][2],
                  triCol[1],triCol[2]})
 call(sgps_code)
 poke4(sgps_data,{triCoords[2][1],triCoords[3][1],triCoords[2][2],triCoords[3][2],
                  triCol[2],triCol[3]})
 call(sgps_code)
 poke4(sgps_data,{triCoords[3][1],triCoords[1][1],triCoords[3][2],triCoords[1][2],
                  triCol[3],triCol[1]})
 call(sgps_code)
 ymin=triCoords[1][2]
 ymax=ymin
 for i=2 to 3 do
  if triCoords[i][2]<ymin then ymin=triCoords[i][2] end if
  if triCoords[i][2]>ymax then ymax=triCoords[i][2] end if
 end for 
 if (ymax>=0 and ymin<200) then
  if ymin<0 then ymin=0 end if
  if ymax>199 then ymax=199 end if
  poke4(ghl_numlines,(ymax-ymin)+1)
  poke4(ghl_y,ymin)
  poke4(ghl_scraddr,triAddr)
  call(ghl_code)
 end if
end procedure

global procedure asm_texturetri_ex(sequence triCoords,sequence texCoords,atom texture,atom triAddr)
integer ymin,ymax
 call(reset_minmax_buffers)
 poke4(stps_data,{triCoords[1][1],triCoords[2][1],triCoords[1][2],triCoords[2][2],
                  texCoords[1][1],texCoords[2][1],texCoords[1][2],texCoords[2][2]})
 call(stps_code)
 poke4(stps_data,{triCoords[2][1],triCoords[3][1],triCoords[2][2],triCoords[3][2],
                 texCoords[2][1],texCoords[3][1],texCoords[2][2],texCoords[3][2]})
 call(stps_code)
 poke4(stps_data,{triCoords[3][1],triCoords[1][1],triCoords[3][2],triCoords[1][2],
                 texCoords[3][1],texCoords[1][1],texCoords[3][2],texCoords[1][2]})
 call(stps_code)
 ymin=triCoords[1][2]
 ymax=ymin
 for i=2 to 3 do
  if triCoords[i][2]<ymin then ymin=triCoords[i][2] end if
  if triCoords[i][2]>ymax then ymax=triCoords[i][2] end if
 end for 
 if (ymax>=0 and ymin<200) then
  if ymin<0 then ymin=0 end if
  if ymax>199 then ymax=199 end if
  poke4(thl_numlines,(ymax-ymin)+1)
  poke4(thl_y,ymin)
  poke4(thl_scraddr,triAddr)
  poke4(thl_texture,texture)
  call(thl_code)
 end if
end procedure


global procedure asm_quad_ex(sequence quadCoords,integer quadCol,atom quadAddr)
integer ymin,ymax
 call(reset_minmax_buffers)
 poke4(sps_data,{quadCoords[1][1],quadCoords[2][1],quadCoords[1][2],quadCoords[2][2]})
 call(sps_code)
 poke4(sps_data,{quadCoords[2][1],quadCoords[3][1],quadCoords[2][2],quadCoords[3][2]})
 call(sps_code)
 poke4(sps_data,{quadCoords[3][1],quadCoords[4][1],quadCoords[3][2],quadCoords[4][2]})
 call(sps_code)
 poke4(sps_data,{quadCoords[4][1],quadCoords[1][1],quadCoords[4][2],quadCoords[1][2]})
 call(sps_code)
 ymin=quadCoords[1][2]
 ymax=ymin
 for i=2 to 4 do
  if quadCoords[i][2]<ymin then ymin=quadCoords[i][2] end if
  if quadCoords[i][2]>ymax then ymax=quadCoords[i][2] end if
 end for 
 if (ymax>=0 and ymin<200) then
  if ymin<0 then ymin=0 end if
  if ymax>199 then ymax=199 end if
  poke4(hl_y,ymin)
  poke4(hl_numlines,(ymax-ymin)+1)
  poke4(hl_color,quadCol)
  poke4(hl_scraddr,quadAddr)
  call(hl_code)
 end if
end procedure


global procedure asm_gouraudquad_ex(sequence quadCoords,sequence quadCol,atom quadAddr)
integer ymin,ymax
 call(reset_minmax_buffers)
 poke4(sgps_data,{quadCoords[1][1],quadCoords[2][1],quadCoords[1][2],quadCoords[2][2],
                  quadCol[1],quadCol[2]})
 call(sgps_code)
 poke4(sgps_data,{quadCoords[2][1],quadCoords[3][1],quadCoords[2][2],quadCoords[3][2],
                  quadCol[2],quadCol[3]})
 call(sgps_code)
 poke4(sgps_data,{quadCoords[3][1],quadCoords[4][1],quadCoords[3][2],quadCoords[4][2],
                  quadCol[3],quadCol[4]})
 call(sgps_code)
 poke4(sgps_data,{quadCoords[4][1],quadCoords[1][1],quadCoords[4][2],quadCoords[1][2],
                  quadCol[4],quadCol[1]})
 call(sgps_code)
 ymin=quadCoords[1][2]
 ymax=ymin
 for i=2 to 4 do
  if quadCoords[i][2]<ymin then ymin=quadCoords[i][2] end if
  if quadCoords[i][2]>ymax then ymax=quadCoords[i][2] end if
 end for 
 if (ymax>=0 and ymin<200) then
  if ymin<0 then ymin=0 end if
  if ymax>199 then ymax=199 end if
  poke4(ghl_numlines,(ymax-ymin)+1)
  poke4(ghl_y,ymin)
  poke4(ghl_scraddr,quadAddr)
  call(ghl_code)
 end if
end procedure


global procedure asm_texturequad_ex(sequence quadCoords,sequence texCoords,atom texture,atom quadAddr)
integer ymin,ymax
 call(reset_minmax_buffers)
 poke4(stps_data,{quadCoords[1][1],quadCoords[2][1],quadCoords[1][2],quadCoords[2][2],
                  texCoords[1][1],texCoords[2][1],texCoords[1][2],texCoords[2][2]})
 call(stps_code)
 poke4(stps_data,{quadCoords[2][1],quadCoords[3][1],quadCoords[2][2],quadCoords[3][2],
                 texCoords[2][1],texCoords[3][1],texCoords[2][2],texCoords[3][2]})
 call(stps_code)
 poke4(stps_data,{quadCoords[3][1],quadCoords[4][1],quadCoords[3][2],quadCoords[4][2],
                 texCoords[3][1],texCoords[4][1],texCoords[3][2],texCoords[4][2]})
 call(stps_code)
 poke4(stps_data,{quadCoords[4][1],quadCoords[1][1],quadCoords[4][2],quadCoords[1][2],
                  texCoords[4][1],texCoords[1][1],texCoords[4][2],texCoords[1][2]})
 call(stps_code)
 ymin=quadCoords[1][2]
 ymax=ymin
 for i=2 to 4 do
  if quadCoords[i][2]<ymin then ymin=quadCoords[i][2] end if
  if quadCoords[i][2]>ymax then ymax=quadCoords[i][2] end if
 end for 
 if (ymax>=0 and ymin<200) then
  if ymin<0 then ymin=0 end if
  if ymax>199 then ymax=199 end if
  poke4(thl_numlines,(ymax-ymin)+1)
  poke4(thl_y,ymin)
  poke4(thl_scraddr,quadAddr)
  poke4(thl_texture,texture)
  call(thl_code)
 end if
end procedure



global procedure asm_polygon_ex(sequence polyCoords,integer polyCol,atom polyAddr)
integer ymin,ymax
integer vertexes
 call(reset_minmax_buffers)
 vertexes=length(polyCoords)
 for i=1 to (vertexes-1) do
  poke4(sps_data,{polyCoords[i][1],polyCoords[i+1][1],polyCoords[i][2],polyCoords[i+1][2]})
  call(sps_code)
 end for
 poke4(sps_data,{polyCoords[vertexes][1],polyCoords[1][1],polyCoords[vertexes][2],polyCoords[1][2]})
 call(sps_code)
 ymin=polyCoords[1][2]
 ymax=ymin
 for i=2 to vertexes do
  if polyCoords[i][2]<ymin then ymin=polyCoords[i][2] end if
  if polyCoords[i][2]>ymax then ymax=polyCoords[i][2] end if
 end for 
 if (ymax>=0 and ymin<200) then
  if ymin<0 then ymin=0 end if
  if ymax>199 then ymax=199 end if
  poke4(hl_y,ymin)
  poke4(hl_numlines,(ymax-ymin)+1)
  poke4(hl_color,polyCol)
  poke4(hl_scraddr,polyAddr)
  call(hl_code)
 end if
end procedure


global procedure asm_gouraudpolygon_ex(sequence polyCoords,sequence polyCol,atom polyAddr)
integer ymin,ymax
integer vertexes
 call(reset_minmax_buffers)
 vertexes=length(polyCoords)
 for i=1 to (vertexes-1) do
  poke4(sgps_data,{polyCoords[i][1],polyCoords[i+1][1],polyCoords[i][2],polyCoords[i+1][2],
                   polyCol[i],polyCol[i+1]})
  call(sgps_code)
 end for
 poke4(sgps_data,{polyCoords[vertexes][1],polyCoords[1][1],polyCoords[vertexes][2],polyCoords[1][2],
                  polyCol[vertexes],polyCol[1]})
 call(sgps_code)
 ymin=polyCoords[1][2]
 ymax=ymin
 for i=2 to vertexes do
  if polyCoords[i][2]<ymin then ymin=polyCoords[i][2] end if
  if polyCoords[i][2]>ymax then ymax=polyCoords[i][2] end if
 end for 
 if (ymax>=0 and ymin<200) then
  if ymin<0 then ymin=0 end if
  if ymax>199 then ymax=199 end if
  poke4(ghl_numlines,(ymax-ymin)+1)
  poke4(ghl_y,ymin)
  poke4(ghl_scraddr,polyAddr)
  call(ghl_code)
 end if
end procedure


global procedure asm_texturepolygon_ex(sequence polyCoords,sequence texCoords,atom texture,atom polyAddr)
integer ymin,ymax
integer vertexes
 call(reset_minmax_buffers)
 vertexes=length(polyCoords)
 for i=1 to (vertexes-1) do
  poke4(stps_data,{polyCoords[i][1],polyCoords[i+1][1],polyCoords[i][2],polyCoords[i+1][2],
                   texCoords[i][1],texCoords[i+1][1],texCoords[i][2],texCoords[i+1][2]})
  call(stps_code)
 end for
 poke4(stps_data,{polyCoords[vertexes][1],polyCoords[1][1],polyCoords[vertexes][2],polyCoords[1][2],
                 texCoords[vertexes][1],texCoords[1][1],texCoords[vertexes][2],texCoords[1][2]})
 call(stps_code)
 ymin=polyCoords[1][2]
 ymax=ymin
 for i=2 to vertexes do
  if polyCoords[i][2]<ymin then ymin=polyCoords[i][2] end if
  if polyCoords[i][2]>ymax then ymax=polyCoords[i][2] end if
 end for 
 if (ymax>=0 and ymin<200) then
  if ymin<0 then ymin=0 end if
  if ymax>199 then ymax=199 end if
  poke4(thl_numlines,(ymax-ymin)+1)
  poke4(thl_y,ymin)
  poke4(thl_scraddr,polyAddr)
  poke4(thl_texture,texture)
  call(thl_code)
 end if
end procedure

--** </Main routines> **--